Public Class ProgressStatusBar
    Inherits System.Windows.Forms.StatusBar

    Private __PanelCount As Integer
    Private __ShowProgressBar As Boolean
    Private __ProgressBarPanel As Integer = (-1)

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        Me.Controls.Add(Me.pgb)
    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private WithEvents pgb As System.Windows.Forms.ProgressBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.pgb = New System.Windows.Forms.ProgressBar
        '
        'pgb
        '
        Me.pgb.Location = New System.Drawing.Point(17, 17)
        Me.pgb.Name = "pgb"
        Me.pgb.TabIndex = 0
        Me.pgb.Visible = False

    End Sub

#End Region

    Public Property ProgressBarPanel() As Integer
        Get
            Return __ProgressBarPanel
        End Get
        Set(ByVal Value As Integer)
            '*
            '* Do we need to proecess it?
            '*
            If (Value = __ProgressBarPanel) Then
                Exit Property
            End If

            '*
            '* Validate the input
            '*
            __PanelCount = 0
            For Each p As Object In Me.Panels
                __PanelCount += 1
            Next
            __PanelCount -= 1
            If ((Value < 0) OrElse (Value > __PanelCount)) Then
                Throw New ArgumentOutOfRangeException("Value", Value & " is out of the valid range [0.." & __PanelCount & "]")
            End If

            '*
            '* Adjust previous container
            '*
            If (__ProgressBarPanel <> (-1)) Then
                Me.Panels(__ProgressBarPanel).Style = StatusBarPanelStyle.Text
            End If

            '*
            '* Accept the change
            '*
            __ProgressBarPanel = Value

            '*
            '* Adjust new container
            '*
            If (Me.pgb.Visible) Then
                Me.Panels(__ProgressBarPanel).Style = StatusBarPanelStyle.OwnerDraw
            End If
        End Set
    End Property

    Public Property ShowProgressBar() As Boolean
        Get
            Return __ShowProgressBar
        End Get
        Set(ByVal Value As Boolean)
            If (__ProgressBarPanel <> (-1)) Then
                Me.Panels(__ProgressBarPanel).Style = IIf(Value, StatusBarPanelStyle.OwnerDraw, StatusBarPanelStyle.Text)
                Me.pgb.Visible = (MyBase.ShowPanels) AndAlso (Value)
                __ShowProgressBar = Value
            End If
        End Set
    End Property

    Private Sub Reposition(ByVal sender As Object, ByVal sbdevent As System.Windows.Forms.StatusBarDrawItemEventArgs) Handles MyBase.DrawItem

        If (Me.DesignMode) Then
            Me.pgb.Minimum = 0
            Me.pgb.Maximum = 100
            Me.pgb.Value = 50
        End If

        If (__ProgressBarPanel <> (-1)) Then
            Me.pgb.Location = New Point(sbdevent.Bounds.X, sbdevent.Bounds.Y)
            Me.pgb.Size = New Size(sbdevent.Bounds.Width, sbdevent.Bounds.Height)
            Me.pgb.Show()
        End If

    End Sub

    Public ReadOnly Property Progress() As ProgressBar
        Get
            Return Me.pgb
        End Get
    End Property

    Public Shadows Property ShowPanels() As Boolean
        Get
            Return MyBase.ShowPanels
        End Get
        Set(ByVal Value As Boolean)
            MyBase.ShowPanels = Value
            If (Value) Then
                Me.pgb.Visible = __ShowProgressBar
            Else
                Me.pgb.Hide()
            End If
        End Set
    End Property

End Class
